
/*	$Id: bnews-protocol-encode.c,v 1.2 2002/07/22 21:15:27 stef Exp $ */

#include "bnews.h"

int EnCode(unsigned char *in, unsigned char *out, int BlockSize)
{
    register int i, j;
    unsigned long long temp[7];

    if (BlockSize != DATASIZE || in == NULL)
	return 0;

    memset(out, 0, CODESIZE);

    for (i = 0; i < 6; i++)
	temp[i] = 0x00;

    for (i = 0; i < DATASIZE; i++) {
	temp[i / 7] += ((unsigned long long) in[i] << 8 * (i % 7));
    }

    for (i = DATASIZE; i >= 0; i--) {

	for (j = i / 7; j > 0; j--) {
	    temp[j - 1] += (temp[j] % 0xe0) << 56;
	    temp[j] /= 0xe0;
	}
	out[DATASIZE - i] = (temp[0] % 0xe0) + 0x20;
	temp[0] /= 0xe0;
    }

    return 1;

}
