/*	$Id: bnews-protocol-decode.c,v 1.3 2002/08/08 21:37:43 stef Exp $ */

#include "bnews.h"

int DeCode(unsigned char *in, unsigned char *out, int BlockSize)
{
    register int i, j, k, l, m;
    unsigned long long temp[6];

    if (BlockSize != DATASIZE || in == NULL)
	return 0;

    temp[0] = in[40] - 0x20;
    l = 39;
    for (j = 1; j < 7; j++) {
	temp[0] *= 0xe0;
	temp[0] += in[l--] - 0x20;
    }
    for (i = 1; i < 5; i++) {
	temp[i] = 0x00;
	for (j = 0; j < 7; j++) {
	    temp[0] *= 0xe0;
	    temp[0] += in[l--] - 0x20;
	    for (k = 1, m = 0; k <= i; m = k++) {
		temp[k] *= 0xe0;
		temp[k] += temp[m] >> 56;
		temp[m] &= 0x00ffffffffffffff;
	    }
	}
    }
    temp[5] = 0x00;
    for (j = 0; j < 6; j++) {
	temp[0] *= 0xe0;
	temp[0] += in[l--] - 0x20;
	for (k = 1, m = 0; k <= 5; m = k++) {
	    temp[k] *= 0xe0;
	    temp[k] += temp[m] >> 56;
	    temp[m] &= 0x00ffffffffffffff;
	}
    }

    j = 0;
    for (i = 0; i < DATASIZE; i++) {
	j = i / 7;
	out[i] = temp[j] & 0xff;
	temp[j] >>= 8;
    }
    return 1;

}
